<template>
  <v-fade-transition>
    <v-overlay opacity="0.5" class="filter-overlay align-start" :value="value" absolute>
      <v-card width="90%" class="d-flex flex-column justify-start pa-3" light tile>
        <v-row no-gutters>
          <v-col>
            <h3 class="pb-2 px-2 font-weight-medium accent--text">
              Amenities
            </h3>
          </v-col>
          <v-col class="shrink">
            <v-btn icon small color="accent darken-1" @click="$emit('input', false)">
              <v-icon>{{ mdiClose }}</v-icon>
            </v-btn>
          </v-col>
        </v-row>
        <v-divider />
        <v-row class="px-2 py-3" dense>
          <v-col
            v-for="checkbox in checkboxs"
            :key="checkbox.key"
            cols="6"
          >
            <v-checkbox
              :input-value="filters[checkbox.key]"
              hide-details
              color="accent"
              class="mt-0"
              dense
              :label="checkbox.title"
              @change="setFilter(checkbox.key, $event)"
            />
          </v-col>
        </v-row>
      </v-card>
    </v-overlay>
  </v-fade-transition>
</template>

<script lang="ts">
import { mdiClose } from '@mdi/js'
import { defineComponent } from '@vue/composition-api'
import { useQuery } from '../hooks'
import { CheckFilters } from '../utils/query'

const checkboxs: Array<{ key: CheckFilters, title: string}> = [
  { key: 'hasAir', title: 'Air Conditioning' },
  { key: 'hasPool', title: 'Pool' },
  { key: 'hasWasher', title: 'Washer/Dryer Hookup' },
  { key: 'hasWiFi', title: 'Wi-Fi at Pool and Clubhouse' },
  { key: 'hasMaintenance', title: 'Maintenance on site' },
  { key: 'hasCourtyard', title: 'Courtyard' },
  { key: 'hasPicnic', title: 'Picnic Area' },
  { key: 'hasBike', title: 'Bike Storage' }
]

export default defineComponent({
  name: 'AppFilters',
  props: {
    value: {
      type: Boolean,
      default: false
    }
  },
  setup (_, context) {
    const { filters, setFilter } = useQuery(context)

    return { checkboxs, filters, setFilter, mdiClose }
  }
})
</script>
